From 7e48bdeaebcaec19b572eabd027bc9610f5474a4 Mon Sep 17 00:00:00 2001
From: Mariam Elshakfy <mariam.elshakfy@linaro.org>
Date: Tue, 15 Oct 2024 15:22:12 +0000
Subject: [PATCH] Silicon/AMD/Xilinx/CommonPkg: Add Mmc Support

This change introduces Arasan Mmc driver, which is common
to Xilinx platforms. The Mmc driver is based on:
Platform/RaspberryPi/Drivers/ArasanMmcHostDxe

This driver currently doesn't support SD high speed
mode, or eMMC

Upstream-Status: Submitted
Co-authored-by: Michal Simek <michal.simek@amd.com>
Signed-off-by: Mariam Elshakfy <mariam.elshakfy@linaro.org>
---
 .../ArasanMmcHostDxe/ArasanMmcHostDxe.c       | 924 ++++++++++++++++++
 .../ArasanMmcHostDxe/ArasanMmcHostDxe.h       | 389 ++++++++
 .../ArasanMmcHostDxe/ArasanMmcHostDxe.inf     |  49 +
 3 files changed, 1362 insertions(+)
 create mode 100644 Silicon/AMD/Xilinx/CommonPkg/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.c
 create mode 100644 Silicon/AMD/Xilinx/CommonPkg/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.h
 create mode 100644 Silicon/AMD/Xilinx/CommonPkg/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.inf

diff --git a/Silicon/AMD/Xilinx/CommonPkg/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.c b/Silicon/AMD/Xilinx/CommonPkg/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.c
new file mode 100644
index 0000000000..6288249f3f
--- /dev/null
+++ b/Silicon/AMD/Xilinx/CommonPkg/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.c
@@ -0,0 +1,924 @@
+/** @file
+ *
+ * Mmc Driver for Arasan SD 3.0/SDIO 3.0/eMMC 4.51 Host Controller
+ * This doesn't support high speed mode yet, or eMMC.
+ *
+ * Copyright (c) 2025, Linaro Ltd. All rights reserved.
+ *
+ * SPDX-License-Identifier: BSD-2-Clause-Patent
+ *
+ * Derived from Platform/RaspberryPi/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.c
+ *
+ **/
+
+#include "ArasanMmcHostDxe.h"
+
+STATIC BOOLEAN            mCardIsPresent   = FALSE;
+STATIC CARD_DETECT_STATE  mCardDetectState = CardDetectRequired;
+STATIC EFI_GUID           mArasanDevicePathGuid = EFI_CALLER_ID_GUID;
+
+EFI_MMC_HOST_PROTOCOL  gMMCHost =
+{
+  MMC_HOST_PROTOCOL_REVISION,
+  MMCIsCardPresent,
+  MMCIsReadOnly,
+  MMCBuildDevicePath,
+  MMCNotifyState,
+  MMCSendCommand,
+  MMCReceiveResponse,
+  MMCReadBlockData,
+  MMCWriteBlockData,
+  NULL, /* SetIos is NULL as we don't support bus width change or high speed mode yet */
+  MMCIsMultiBlock
+};
+
+/**
+   Write to SDHCI registers with delay to avoid failures
+ **/
+STATIC
+UINT32
+EFIAPI
+SdMmioWrite32 (
+  IN      UINTN   Address,
+  IN      UINT32  Value
+  )
+{
+  UINT32  ReturnValue = 0;
+
+  ReturnValue = MmioWrite32 (Address, Value);
+  gBS->Stall (STALL_AFTER_REG_WRITE_US);
+  return ReturnValue;
+}
+
+STATIC
+UINT32
+EFIAPI
+SdMmioOr32 (
+  IN      UINTN   Address,
+  IN      UINT32  OrData
+  )
+{
+  return SdMmioWrite32 (Address, MmioRead32 (Address) | OrData);
+}
+
+STATIC
+UINT32
+EFIAPI
+SdMmioAnd32 (
+  IN      UINTN   Address,
+  IN      UINT32  AndData
+  )
+{
+  return SdMmioWrite32 (Address, MmioRead32 (Address) & AndData);
+}
+
+STATIC
+UINT32
+EFIAPI
+SdMmioAndThenOr32 (
+  IN      UINTN   Address,
+  IN      UINT32  AndData,
+  IN      UINT32  OrData
+  )
+{
+  return SdMmioWrite32 (Address, (MmioRead32 (Address) & AndData) | OrData);
+}
+
+/**
+   Ignore commands that are not supported yet
+ **/
+STATIC
+BOOLEAN
+IgnoreCommand (
+  UINT32  Command
+  )
+{
+  BOOLEAN  Result = FALSE;
+
+  switch (Command) {
+    /*
+     * We don't support high speed mode in this implementation yet
+     */
+    case MMC_CMD6:
+      Result = TRUE;
+      break;
+
+    /*
+     * No other commands should be ignored
+     */
+    default:
+      Result = FALSE;
+      break;
+  }
+
+  return Result;
+}
+
+/**
+   Translates a generic SD command into the format used by the Arasan SD Host Controller
+**/
+STATIC
+UINT32
+TranslateCommand (
+  UINT32  Command,
+  UINT32  Argument
+  )
+{
+  UINT32  Translation = INVALID_CMD;
+
+  switch (Command) {
+    case MMC_CMD0:
+      Translation = CMD0;
+      break;
+    case MMC_CMD1:
+      Translation = CMD1;
+      break;
+    case MMC_CMD2:
+      Translation = CMD2;
+      break;
+    case MMC_CMD3:
+      Translation = CMD3;
+      break;
+    case MMC_CMD5:
+      Translation = CMD5;
+      break;
+    case MMC_CMD6:
+      Translation = CMD6;
+      break;
+    case MMC_CMD7:
+      Translation = CMD7;
+      break;
+    case MMC_CMD8:
+    {
+      if (Argument == CMD8_SD_ARG) {
+        Translation = CMD8_SD;
+      } else {
+        ASSERT (Argument == CMD8_MMC_ARG);
+        Translation = CMD8_MMC;
+      }
+
+      break;
+    }
+    case MMC_CMD9:
+      Translation = CMD9;
+      break;
+    case MMC_CMD11:
+      Translation = CMD11;
+      break;
+    case MMC_CMD12:
+      Translation = CMD12;
+      break;
+    case MMC_CMD13:
+      Translation = CMD13;
+      break;
+    case MMC_CMD16:
+      Translation = CMD16;
+      break;
+    case MMC_CMD17:
+      Translation = CMD17;
+      break;
+    case MMC_CMD18:
+      Translation = CMD18;
+      break;
+    case MMC_CMD23:
+      Translation = CMD23;
+      break;
+    case MMC_CMD24:
+      Translation = CMD24;
+      break;
+    case MMC_CMD25:
+      Translation = CMD25;
+      break;
+    case MMC_CMD55:
+      Translation = CMD55;
+      break;
+    case MMC_ACMD41:
+      Translation = ACMD41;
+      break;
+    case MMC_ACMD51:
+      Translation = ACMD51;
+      break;
+    default:
+      DEBUG ((DEBUG_ERROR, "ArasanMMCHost: TranslateCommand(): Unrecognized Command: %d\n", Command));
+      break;
+  }
+
+  return Translation;
+}
+
+/**
+   Repeatedly polls a register until its value becomes correct, or until MAX_RETRY_COUNT polls is reached
+**/
+STATIC
+EFI_STATUS
+PollRegisterWithMask (
+  IN UINTN  Register,
+  IN UINTN  Mask,
+  IN UINTN  ExpectedValue
+  )
+{
+  UINT32  RetryCount = 0;
+
+  while (RetryCount < MAX_RETRY_COUNT) {
+    if ((MmioRead32 (Register) & Mask) != ExpectedValue) {
+      RetryCount++;
+      gBS->Stall (STALL_AFTER_RETRY_US);
+    } else {
+      break;
+    }
+  }
+
+  if (RetryCount == MAX_RETRY_COUNT) {
+    return EFI_TIMEOUT;
+  }
+
+  return EFI_SUCCESS;
+}
+
+/**
+   Perform soft reset
+**/
+STATIC
+EFI_STATUS
+SoftReset (
+  IN UINT32  Mask
+  )
+{
+  DEBUG ((DEBUG_MMCHOST_SD, "ArasanMMCHost: SoftReset with mask 0x%x\n", Mask));
+
+  SdMmioOr32 (MMCHS_SYSCTL, Mask);
+
+  if (PollRegisterWithMask (MMCHS_SYSCTL, Mask, 0) == EFI_TIMEOUT) {
+    DEBUG ((DEBUG_ERROR, "ArasanMMCHost: Failed to SoftReset with mask 0x%x\n", Mask));
+    return EFI_TIMEOUT;
+  }
+
+  return EFI_SUCCESS;
+}
+
+/**
+   Calculate the clock divisor
+**/
+STATIC
+EFI_STATUS
+CalculateClockFrequencyDivisor (
+  IN  UINTN   TargetFrequency,
+  OUT UINT32  *DivisorValue,
+  OUT UINTN   *ActualFrequency
+  )
+{
+  UINT32  Divisor       = 0;
+  UINT32  BaseFrequency = MMCHS_BASE_FREQUENCY;
+
+  ASSERT (BaseFrequency != 0);
+  ASSERT (TargetFrequency != 0);
+  Divisor = BaseFrequency / TargetFrequency;
+
+  /*
+   * Arasan controller is based on 3.0 spec so the div is multiple of 2
+   * Actual Frequency = BaseFequency/(Div*2)
+   */
+  Divisor /= 2;
+
+  if ((TargetFrequency < BaseFrequency) &&
+      (TargetFrequency * 2 * Divisor != BaseFrequency))
+  {
+    Divisor += 1;
+  }
+
+  if (Divisor > MAX_DIVISOR_VALUE) {
+    Divisor = MAX_DIVISOR_VALUE;
+  }
+
+  DEBUG ((DEBUG_MMCHOST_SD, "ArasanMMCHost: BaseFrequency 0x%x Divisor 0x%x\n", BaseFrequency, Divisor));
+
+  *DivisorValue  = (Divisor & 0xFF) << 8;
+  Divisor      >>= 8;
+  *DivisorValue |= (Divisor & 0x03) << 6;
+
+  if (ActualFrequency) {
+    if (Divisor == 0) {
+      *ActualFrequency = BaseFrequency;
+    } else {
+      *ActualFrequency   = BaseFrequency / Divisor;
+      *ActualFrequency >>= 1;
+    }
+
+    DEBUG ((DEBUG_MMCHOST_SD, "ArasanMMCHost: *ActualFrequency 0x%x\n", *ActualFrequency));
+  }
+
+  DEBUG ((DEBUG_MMCHOST_SD, "ArasanMMCHost: *DivisorValue 0x%x\n", *DivisorValue));
+
+  return EFI_SUCCESS;
+}
+
+/******************** Protocol Member Functions ********************/
+
+STATIC
+BOOLEAN
+EFIAPI
+MMCIsReadOnly (
+  IN EFI_MMC_HOST_PROTOCOL  *This
+  )
+{
+  BOOLEAN  IsReadOnly = FALSE;
+
+  if (PcdGetBool (PcdEnableMmcWPDetection)) {
+    IsReadOnly = !((MmioRead32 (MMCHS_PRES_STATE) & WRITE_PROTECT_OFF) == WRITE_PROTECT_OFF);
+    DEBUG ((DEBUG_MMCHOST_SD, "ArasanMMCHost: MMCIsReadOnly(): %d\n", IsReadOnly));
+  } else {
+    IsReadOnly = FALSE;
+  }
+
+  return IsReadOnly;
+}
+
+STATIC
+EFI_STATUS
+EFIAPI
+MMCBuildDevicePath (
+  IN EFI_MMC_HOST_PROTOCOL         *This,
+  IN OUT EFI_DEVICE_PATH_PROTOCOL  **DevicePath
+  )
+{
+  EFI_STATUS                Status             = EFI_SUCCESS;
+  EFI_DEVICE_PATH_PROTOCOL  *NewDevicePathNode = NULL;
+
+  DEBUG ((DEBUG_MMCHOST_SD, "ArasanMMCHost: MMCBuildDevicePath()\n"));
+
+  NewDevicePathNode = CreateDeviceNode (HARDWARE_DEVICE_PATH, HW_VENDOR_DP, sizeof (VENDOR_DEVICE_PATH));
+
+  if (NewDevicePathNode == NULL) {
+    Status = EFI_OUT_OF_RESOURCES;
+  } else {
+    CopyGuid (&((VENDOR_DEVICE_PATH *)NewDevicePathNode)->Guid, &mArasanDevicePathGuid);
+    *DevicePath = NewDevicePathNode;
+    Status      = EFI_SUCCESS;
+  }
+
+  return Status;
+}
+
+STATIC
+EFI_STATUS
+EFIAPI
+MMCSendCommand (
+  IN EFI_MMC_HOST_PROTOCOL  *This,
+  IN MMC_CMD                MmcCmd,
+  IN UINT32                 Argument
+  )
+{
+  EFI_STATUS  Status        = EFI_SUCCESS;
+  UINT32      MmcStatus     = 0;
+  UINT32      CmdSendOKMask = 0;
+  UINT32      RetryCount    = 0;
+  BOOLEAN     IsDATCmd      = FALSE;
+
+  DEBUG ((DEBUG_MMCHOST_SD, "ArasanMMCHost: MMCSendCommand(MmcCmd: %08x, Argument: %08x)\n", MmcCmd, Argument));
+
+  if (IgnoreCommand (MmcCmd)) {
+    return EFI_SUCCESS;
+  }
+
+  MmcCmd = TranslateCommand (MmcCmd, Argument);
+
+  if (MmcCmd == INVALID_CMD) {
+    return EFI_UNSUPPORTED;
+  }
+
+  if (
+      /* R1b commands use the busy signal on DAT[0] line, except for CMD12 */
+      (((MmcCmd & CMD_R1B) == CMD_R1B) && (MmcCmd != CMD_STOP_TRANSMISSION)) ||
+      /* ADTC commands are data transfer commands (using DAT line) */
+      ((MmcCmd & CMD_R1_ADTC) == CMD_R1_ADTC)
+     )
+  {
+    IsDATCmd = TRUE;
+  }
+
+  CmdSendOKMask = CMDI;
+
+  if (IsDATCmd) {
+    CmdSendOKMask |= DATI;
+  }
+
+  /* Poll until command line is available */
+  if (PollRegisterWithMask (
+        MMCHS_PRES_STATE,
+        CmdSendOKMask,
+        0
+        ) == EFI_TIMEOUT)
+  {
+    DEBUG ((
+      DEBUG_ERROR,
+      "%a(%u): Timeout reached for MMC_CMD%u PresState 0x%x MmcStatus 0x%x\n",
+      __func__,
+      __LINE__,
+      CMD_TO_INDX (MmcCmd),
+      MmioRead32 (MMCHS_PRES_STATE),
+      MmioRead32 (MMCHS_INT_STAT)
+      ));
+    return EFI_TIMEOUT;
+  }
+
+  /* Provide the block size */
+  if (MmcCmd == ACMD51) {
+    SdMmioWrite32 (MMCHS_BLK, BLEN_8BYTES);
+  } else {
+    SdMmioWrite32 (MMCHS_BLK, BLEN_512BYTES);
+  }
+
+  /* Set Data timeout counter value to max value */
+  SdMmioAndThenOr32 (MMCHS_SYSCTL, (UINT32) ~DTO_MASK, DTO_VAL);
+
+  /*
+   * Clear Interrupt Status Register, but not the Card Inserted bit
+   * to avoid messing with card detection logic.
+   */
+  SdMmioWrite32 (MMCHS_INT_STAT, ALL_EN & ~(CARD_INS));
+
+  /* Set command argument register */
+  SdMmioWrite32 (MMCHS_ARG, Argument);
+
+  /* Send the command */
+  SdMmioWrite32 (MMCHS_CMD, MmcCmd);
+
+  /* Check for the command status */
+  while (RetryCount < MAX_RETRY_COUNT) {
+    MmcStatus = MmioRead32 (MMCHS_INT_STAT);
+
+    /* Check for errors */
+    if ((MmcStatus & ERRI) != 0) {
+      /*
+       * CMD5 (CMD_IO_SEND_OP_COND) is only valid for SDIO
+       * cards and thus expected to fail.
+       */
+      if (MmcCmd != CMD_IO_SEND_OP_COND) {
+        DEBUG ((
+          DEBUG_ERROR,
+          "%a(%u): MMC_CMD%u ERRI MmcStatus 0x%x\n",
+          __func__,
+          __LINE__,
+          CMD_TO_INDX (MmcCmd),
+          MmcStatus
+          ));
+      }
+
+      SoftReset (SRC);
+
+      Status = EFI_DEVICE_ERROR;
+      break;
+    }
+    /* Check if command is completed */
+    else if ((MmcStatus & CC) == CC) {
+      SdMmioWrite32 (MMCHS_INT_STAT, CC);
+      break;
+    }
+
+    RetryCount++;
+    gBS->Stall (STALL_AFTER_RETRY_US);
+  }
+
+  gBS->Stall (STALL_AFTER_SEND_CMD_US);
+
+  if (RetryCount == MAX_RETRY_COUNT) {
+    DEBUG ((
+      DEBUG_ERROR,
+      "%a(%u): MMC_CMD%u completion TIMEOUT PresState 0x%x MmcStatus 0x%x\n",
+      __func__,
+      __LINE__,
+      CMD_TO_INDX (MmcCmd),
+      MmioRead32 (MMCHS_PRES_STATE),
+      MmcStatus
+      ));
+    Status = EFI_TIMEOUT;
+  }
+
+  return Status;
+}
+
+STATIC
+EFI_STATUS
+EFIAPI
+MMCNotifyState (
+  IN EFI_MMC_HOST_PROTOCOL  *This,
+  IN MMC_STATE              State
+  )
+{
+  EFI_STATUS  Status         = EFI_SUCCESS;
+  UINTN       ClockFrequency = 0;
+  UINT32      Divisor        = 0;
+
+  DEBUG ((DEBUG_MMCHOST_SD, "ArasanMMCHost: MMCNotifyState(State: %d)\n", State));
+
+  /* Stall all operations except init until card detection has occurred */
+  if ((State != MmcHwInitializationState) &&
+      (mCardDetectState != CardDetectCompleted))
+  {
+    return EFI_NOT_READY;
+  }
+
+  switch (State) {
+    case MmcHwInitializationState:
+    {
+      DEBUG ((DEBUG_MMCHOST_SD, "ArasanMMCHost: current divisor %x\n", MmioRead32 (MMCHS_SYSCTL)));
+
+      Status = SoftReset (SRA);
+      if (EFI_ERROR (Status)) {
+        return Status;
+      }
+
+      /* Switch to card detect test mode */
+      SdMmioOr32 (MMCHS_HPCTL, CDSS|CDTL);
+
+      /* Set card voltage */
+      SdMmioAnd32 (MMCHS_HPCTL, ~SDBP);
+      SdMmioAndThenOr32 (MMCHS_HPCTL, (UINT32) ~SDBP, SDVS_3_3_V);
+      SdMmioOr32 (MMCHS_HPCTL, SDBP);
+
+      /* First turn off the clock */
+      SdMmioAnd32 (MMCHS_SYSCTL, ~CEN);
+
+      /* Attempt to set the clock to 400Khz which is the expected initialization speed */
+      Status = CalculateClockFrequencyDivisor (MMCHS_INIT_FREQUENCY, &Divisor, NULL);
+      if (EFI_ERROR (Status)) {
+        DEBUG ((DEBUG_ERROR, "ArasanMMCHost: MMCNotifyState(): Fail to initialize SD clock\n"));
+        return Status;
+      }
+
+      /* Set data timeout counter value + clock frequency, and enable internal clock */
+      SdMmioOr32 (MMCHS_SYSCTL, DTO_VAL | Divisor | CEN | ICS | ICE);
+      SdMmioOr32 (MMCHS_HPCTL, SDBP);
+
+      /* Wait for ICS */
+      while ((MmioRead32 (MMCHS_SYSCTL) & ICS) != ICS) {
+      }
+
+      /* Enable interrupts */
+      SdMmioWrite32 (MMCHS_IE, ALL_EN);
+      break;
+    }
+    case MmcIdleState:
+      break;
+    case MmcReadyState:
+      break;
+    case MmcIdentificationState:
+      break;
+    case MmcStandByState:
+    {
+      ClockFrequency = MMCHS_STANDBY_FREQUENCY;
+
+      /* Turn off the SD clock */
+      SdMmioAnd32 (MMCHS_SYSCTL, ~CEN);
+
+      Status = CalculateClockFrequencyDivisor (ClockFrequency, &Divisor, NULL);
+      if (EFI_ERROR (Status)) {
+        DEBUG ((
+          DEBUG_ERROR,
+          "ArasanMMCHost: MmcStandByState(): Fail to initialize SD clock to %u Hz\n",
+          ClockFrequency
+          ));
+        return Status;
+      }
+
+      /* Setup new divisor */
+      SdMmioAndThenOr32 (MMCHS_SYSCTL, (UINT32) ~CLKD_MASK, Divisor);
+
+      /* Wait for the clock to stabilise */
+      while ((MmioRead32 (MMCHS_SYSCTL) & ICS) != ICS) {
+      }
+
+      /* Turn on the SD clock */
+      SdMmioOr32 (MMCHS_SYSCTL, CEN);
+      break;
+    }
+    case MmcTransferState:
+      break;
+    case MmcSendingDataState:
+      break;
+    case MmcReceiveDataState:
+      break;
+    case MmcProgrammingState:
+      break;
+    case MmcDisconnectState:
+    case MmcInvalidState:
+    default:
+      DEBUG ((DEBUG_ERROR, "ArasanMMCHost: MMCNotifyState(): Invalid State: %d\n", State));
+      ASSERT (0);
+  }
+
+  return EFI_SUCCESS;
+}
+
+STATIC
+BOOLEAN
+EFIAPI
+MMCIsCardPresent (
+  IN EFI_MMC_HOST_PROTOCOL  *This
+  )
+{
+  EFI_STATUS  Status = EFI_SUCCESS;
+
+  ASSERT (This != NULL);
+
+  /*
+   * If we are already in progress (we may get concurrent calls)
+   * or completed the detection, just return the current value.
+   */
+  if (mCardDetectState != CardDetectRequired) {
+    return mCardIsPresent;
+  }
+
+  mCardDetectState = CardDetectInProgress;
+  mCardIsPresent   = FALSE;
+
+  /*
+   * The two following commands should succeed even if no card is present.
+   */
+  Status = MMCNotifyState (This, MmcHwInitializationState);
+  if (EFI_ERROR (Status)) {
+    DEBUG ((DEBUG_ERROR, "MMCIsCardPresent: Error MmcHwInitializationState, Status=%r.\n", Status));
+    /* If we failed init, go back to requiring card detection */
+    mCardDetectState = CardDetectRequired;
+    return mCardIsPresent;
+  }
+
+  /*
+   * Reset card to idle state
+   */
+  if (EFI_ERROR (MMCSendCommand (This, MMC_CMD0, 0))) {
+    DEBUG ((DEBUG_ERROR, "MMCIsCardPresent: Failed to reset card (CMD0 Error), Status=%r.\n", Status));
+    mCardIsPresent = FALSE;
+  }
+
+  /*
+   * Check SD Card
+   */
+  else if (!EFI_ERROR (MMCSendCommand (This, MMC_CMD8, CMD8_SD_ARG))) {
+    DEBUG ((DEBUG_INFO, "MMCIsCardPresent: SD card detected.\n"));
+    mCardIsPresent = TRUE;
+  }
+
+  /*
+   * Check MMC/eMMC.
+   */
+  else if (!EFI_ERROR (MMCSendCommand (This, MMC_CMD1, EMMC_CMD1_CAPACITY_GREATER_THAN_2GB))) {
+    DEBUG ((DEBUG_INFO, "MMCIsCardPresent: MMC card detected.\n"));
+    mCardIsPresent = TRUE;
+  }
+
+  /*
+   * Check SDIO.
+   */
+  else if (!EFI_ERROR (MMCSendCommand (This, MMC_CMD5, 0))) {
+    DEBUG ((DEBUG_INFO, "MMCIsCardPresent: SDIO card detected.\n"));
+    mCardIsPresent = TRUE;
+  }
+
+  /*
+   * No card detected.
+   */
+  else {
+    DEBUG ((DEBUG_INFO, "MMCIsCardPresent: No card detected, Status=%r.\n", Status));
+  }
+
+  mCardDetectState = CardDetectCompleted;
+  return mCardIsPresent;
+}
+
+STATIC
+EFI_STATUS
+EFIAPI
+MMCReceiveResponse (
+  IN EFI_MMC_HOST_PROTOCOL  *This,
+  IN MMC_RESPONSE_TYPE      Type,
+  OUT UINT32                *Buffer
+  )
+{
+  if (Buffer == NULL) {
+    DEBUG ((DEBUG_ERROR, "%a(%u): NULL Buffer\n", __func__, __LINE__));
+    return EFI_INVALID_PARAMETER;
+  }
+
+  if (Type == MMC_RESPONSE_TYPE_R2) {
+    /* 16-byte response */
+    Buffer[0] = MmioRead32 (MMCHS_RSP10);
+    Buffer[1] = MmioRead32 (MMCHS_RSP32);
+    Buffer[2] = MmioRead32 (MMCHS_RSP54);
+    Buffer[3] = MmioRead32 (MMCHS_RSP76);
+
+    DEBUG ((
+      DEBUG_MMCHOST_SD,
+      "ArasanMMCHost: MMCReceiveResponse(Type: %x), Buffer[0-3]: %08x, %08x, %08x, %08x\n",
+      Type,
+      Buffer[0],
+      Buffer[1],
+      Buffer[2],
+      Buffer[3]
+      ));
+  } else {
+    /* 4-byte response */
+    Buffer[0] = MmioRead32 (MMCHS_RSP10);
+    DEBUG ((DEBUG_MMCHOST_SD, "ArasanMMCHost: MMCReceiveResponse(Type: %08x), Buffer[0]: %08x\n", Type, Buffer[0]));
+  }
+
+  gBS->Stall (STALL_AFTER_REC_RESP_US);
+
+  return EFI_SUCCESS;
+}
+
+STATIC
+EFI_STATUS
+EFIAPI
+MMCReadBlockData (
+  IN EFI_MMC_HOST_PROTOCOL  *This,
+  IN EFI_LBA                Lba,
+  IN UINTN                  Length,
+  OUT UINT32                *Buffer
+  )
+{
+  UINT32  MmcStatus  = 0;
+  UINT32  RetryCount = 0;
+  UINTN   RemLength  = 0;
+  UINTN   Count      = 0;
+  UINTN   BlockLen   = 0;
+
+  DEBUG ((
+    DEBUG_MMCHOST_SD,
+    "%a(%u): LBA: 0x%x, Length: 0x%x, Buffer: 0x%x)\n",
+    __func__,
+    __LINE__,
+    Lba,
+    Length,
+    Buffer
+    ));
+
+  if (Buffer == NULL) {
+    DEBUG ((DEBUG_ERROR, "%a(%u): NULL Buffer\n", __func__, __LINE__));
+    return EFI_INVALID_PARAMETER;
+  }
+
+  if (Length % sizeof (UINT32) != 0) {
+    DEBUG ((DEBUG_ERROR, "%a(%u): bad Length %u\n", __func__, __LINE__, Length));
+    return EFI_INVALID_PARAMETER;
+  }
+
+  RemLength = Length;
+  while (RemLength != 0) {
+    RetryCount = 0;
+    BlockLen   = MIN (RemLength, BLEN_512BYTES);
+
+    while (RetryCount < MAX_RETRY_COUNT) {
+      MmcStatus = MmioRead32 (MMCHS_INT_STAT);
+      if ((MmcStatus & BRR) != 0) {
+        SdMmioWrite32 (MMCHS_INT_STAT, BRR);
+
+        /*
+         * Data is ready.
+         */
+        for (Count = 0; Count < BlockLen; Count += 4, Buffer++) {
+          *Buffer = MmioRead32 (MMCHS_DATA);
+        }
+
+        break;
+      }
+
+      gBS->Stall (STALL_AFTER_RETRY_US);
+      RetryCount++;
+    }
+
+    if (RetryCount == MAX_RETRY_COUNT) {
+      DEBUG ((
+        DEBUG_ERROR,
+        "%a(%u): %lu/%lu MMCHS_INT_STAT: %08x\n",
+        __func__,
+        __LINE__,
+        Length - RemLength,
+        Length,
+        MmcStatus
+        ));
+      return EFI_TIMEOUT;
+    }
+
+    RemLength -= BlockLen;
+    gBS->Stall (STALL_AFTER_READ_US);
+  }
+
+  SdMmioWrite32 (MMCHS_INT_STAT, BRR);
+  return EFI_SUCCESS;
+}
+
+STATIC
+EFI_STATUS
+EFIAPI
+MMCWriteBlockData (
+  IN EFI_MMC_HOST_PROTOCOL  *This,
+  IN EFI_LBA                Lba,
+  IN UINTN                  Length,
+  IN UINT32                 *Buffer
+  )
+{
+  UINT32  MmcStatus  = 0;
+  UINT32  RetryCount = 0;
+  UINTN   RemLength  = 0;
+  UINTN   Count      = 0;
+  UINTN   BlockLen   = 0;
+
+  DEBUG ((
+    DEBUG_MMCHOST_SD,
+    "%a(%u): LBA: 0x%x, Length: 0x%x, Buffer: 0x%x)\n",
+    __func__,
+    __LINE__,
+    Lba,
+    Length,
+    Buffer
+    ));
+
+  if (Buffer == NULL) {
+    DEBUG ((DEBUG_ERROR, "%a(%u): NULL Buffer\n", __func__, __LINE__));
+    return EFI_INVALID_PARAMETER;
+  }
+
+  if (Length % sizeof (UINT32) != 0) {
+    DEBUG ((DEBUG_ERROR, "%a(%u): bad Length %u\n", __func__, __LINE__, Length));
+    return EFI_INVALID_PARAMETER;
+  }
+
+  RemLength = Length;
+  while (RemLength != 0) {
+    RetryCount = 0;
+    BlockLen   = MIN (RemLength, BLEN_512BYTES);
+
+    while (RetryCount < MAX_RETRY_COUNT) {
+      MmcStatus = MmioRead32 (MMCHS_INT_STAT);
+      if ((MmcStatus & BWR) != 0) {
+        SdMmioWrite32 (MMCHS_INT_STAT, BWR);
+
+        /*
+         * Can write data.
+         */
+        for (Count = 0; Count < BlockLen; Count += 4, Buffer++) {
+          SdMmioWrite32 (MMCHS_DATA, *Buffer);
+        }
+
+        break;
+      }
+
+      gBS->Stall (STALL_AFTER_RETRY_US);
+      RetryCount++;
+    }
+
+    if (RetryCount == MAX_RETRY_COUNT) {
+      DEBUG ((
+        DEBUG_ERROR,
+        "%a(%u): %lu/%lu MMCHS_INT_STAT: %08x\n",
+        __func__,
+        __LINE__,
+        Length - RemLength,
+        Length,
+        MmcStatus
+        ));
+      return EFI_TIMEOUT;
+    }
+
+    RemLength -= BlockLen;
+    gBS->Stall (STALL_AFTER_WRITE_US);
+  }
+
+  SdMmioWrite32 (MMCHS_INT_STAT, BWR);
+  return EFI_SUCCESS;
+}
+
+STATIC
+BOOLEAN
+EFIAPI
+MMCIsMultiBlock (
+  IN EFI_MMC_HOST_PROTOCOL  *This
+  )
+{
+  return TRUE;
+}
+
+/******************** Entry Point ********************/
+EFI_STATUS
+MMCInitialize (
+  IN EFI_HANDLE        ImageHandle,
+  IN EFI_SYSTEM_TABLE  *SystemTable
+  )
+{
+  EFI_STATUS  Status = EFI_SUCCESS;
+  EFI_HANDLE  Handle = NULL;
+
+  DEBUG ((DEBUG_MMCHOST_SD, "----- ArasanMMCHost: MMCInitialize() Start -----\n"));
+
+  Status = gBS->InstallMultipleProtocolInterfaces (
+                  &Handle,
+                  &gEmbeddedMmcHostProtocolGuid,
+                  &gMMCHost,
+                  NULL
+                  );
+
+  ASSERT_EFI_ERROR (Status);
+
+  return Status;
+}
diff --git a/Silicon/AMD/Xilinx/CommonPkg/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.h b/Silicon/AMD/Xilinx/CommonPkg/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.h
new file mode 100644
index 0000000000..af12999301
--- /dev/null
+++ b/Silicon/AMD/Xilinx/CommonPkg/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.h
@@ -0,0 +1,389 @@
+/** @file
+ *
+ * Mmc Driver for Arasan SD 3.0/SDIO 3.0/eMMC 4.51 Host Controller
+ * This doesn't support high speed mode yet, or eMMC.
+ *
+ * Copyright (c) 2025, Linaro Ltd. All rights reserved.
+ *
+ * SPDX-License-Identifier: BSD-2-Clause-Patent
+ *
+ * Derived from Platform/RaspberryPi/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.h
+ *
+ **/
+
+#ifndef ARASAN_MMC_HOST_DXE_H
+#define ARASAN_MMC_HOST_DXE_H
+
+#include <Uefi.h>
+
+#include <Library/BaseMemoryLib.h>
+#include <Library/DebugLib.h>
+#include <Library/DevicePathLib.h>
+#include <Library/IoLib.h>
+#include <Library/PcdLib.h>
+#include <Library/UefiBootServicesTableLib.h>
+
+#include <Protocol/MmcHost.h>
+
+#define MAX_RETRY_COUNT          (20000UL)
+
+/*
+ * The following values are in microseconds
+ */
+#define STALL_AFTER_SEND_CMD_US  (FixedPcdGet64(PcdMmcStallAfterCmdSend))
+#define STALL_AFTER_REC_RESP_US  (FixedPcdGet64(PcdMmcStallAfterResponseReceive))
+#define STALL_AFTER_WRITE_US     (FixedPcdGet64(PcdMmcStallAfterDataWrite))
+#define STALL_AFTER_READ_US      (FixedPcdGet64(PcdMmcStallAfterDataRead))
+#define STALL_AFTER_REG_WRITE_US (FixedPcdGet64(PcdMmcStallAfterRegisterWrite))
+#define STALL_AFTER_RETRY_US     (FixedPcdGet64(PcdMmcStallAfterRetry))
+
+#define MAX_DIVISOR_VALUE        (1023UL)
+
+#define DEBUG_MMCHOST_SD         DEBUG_VERBOSE
+
+/*
+ * MMC/SD/SDIO register definitions.
+ * We don't support eMMC yet (MMCHS1_BASE).
+ * Therefore, this implementation will force using
+ * MMCHS2_BASE
+ */
+#define MMCHS_BASE               (FixedPcdGet64 (PcdSdhciBase))
+
+/*
+ * High speed mode is not supported yet, so this implementation
+ * currently only runs at 25MHz speed
+ */
+#define MMCHS_BASE_FREQUENCY     (200000000UL)
+#define MMCHS_STANDBY_FREQUENCY  (25000000UL)
+#define MMCHS_INIT_FREQUENCY     (400000UL)
+
+#define MMCHS_BLK                (MMCHS_BASE + 0x4)
+#define  BLEN_8BYTES             (0x8UL)
+#define  BLEN_512BYTES           (0x200UL)
+
+#define MMCHS_ARG                (MMCHS_BASE + 0x8)
+
+/*
+ * This represents 2 registers (Transfer Mode & Command)
+ * for simpler command representation
+ */
+#define MMCHS_CMD                 (MMCHS_BASE + 0xC)
+#define  DDIR_READ                BIT4
+#define  DDIR_WRITE               ~BIT4
+#define  MSBS_MULTBLK             BIT5
+#define  RSP_TYPE_MASK            (0x3UL << 16)
+#define   RSP_TYPE_136BITS        (0x1UL << 16)
+#define   RSP_TYPE_48BITS         (0x2UL << 16)
+#define   RSP_TYPE_48BUSY         (0x3UL << 16)
+#define  CCCE_ENABLE              BIT19
+#define  CICE_ENABLE              BIT20
+#define  DP_ENABLE                BIT21
+#define  CMD_TYPE_MASK            (0x3UL  << 22)
+#define   CMD_TYPE_NORMAL         (0x0UL  << 22)
+#define   CMD_TYPE_ABORT          (0x3UL  << 22)
+
+#define TYPE(CMD_TYPE)            (((CMD_TYPE) & (CMD_TYPE_MASK)))
+#define CMD_INDX_MASK             (0x3FUL << 24)
+#define INDX_TO_CMD(CMD_INDX)     ((CMD_INDX << 24) & CMD_INDX_MASK)
+#define CMD_TO_INDX(CMD)          (((CMD) & CMD_INDX_MASK) >> 24)
+#define NORMAL_CMD(CMD_INDX)      (TYPE(CMD_TYPE_NORMAL) | INDX_TO_CMD(CMD_INDX))
+#define ABORT_CMD(CMD_INDX)       (TYPE(CMD_TYPE_ABORT) | INDX_TO_CMD(CMD_INDX))
+
+#define MMCHS_RSP10               (MMCHS_BASE + 0x10)
+#define MMCHS_RSP32               (MMCHS_BASE + 0x14)
+#define MMCHS_RSP54               (MMCHS_BASE + 0x18)
+#define MMCHS_RSP76               (MMCHS_BASE + 0x1C)
+#define MMCHS_DATA                (MMCHS_BASE + 0x20)
+
+#define MMCHS_PRES_STATE          (MMCHS_BASE + 0x24)
+#define  CMDI                     BIT0
+#define  DATI                     BIT1
+#define  WRITE_PROTECT_OFF        BIT19
+
+/*
+ * This represents 2 registers (Host Control 1 & Power Control)
+ * for simpler implementation
+ */
+#define MMCHS_HPCTL               (MMCHS_BASE + 0x28)
+#define  CDTL                     BIT6
+#define  CDSS                     BIT7
+#define  SDBP                     BIT8
+#define  SDVS_MASK                (0x7UL << 9)
+#define   SDVS_1_8_V              (0x5UL << 9)
+#define   SDVS_3_0_V              (0x6UL << 9)
+#define   SDVS_3_3_V              (0x7UL << 9)
+
+/*
+ * This represents 2 registers (Clock and Timeout Control)
+ * for simpler implementation
+ */
+#define MMCHS_SYSCTL              (MMCHS_BASE + 0x2C)
+#define  ICE                      BIT0
+#define  ICS                      BIT1
+#define  CEN                      BIT2
+#define  CLKD_MASK                (0x3FFUL << 6)
+#define   CLKD_80KHZ              (0x258UL)        /* (96*1000/80)/2 */
+#define   CLKD_400KHZ             (0xF0UL)
+#define   CLKD_12500KHZ           (0x200UL)
+#define  DTO_MASK                 (0xFUL << 16)
+#define   DTO_VAL                 (0xEUL << 16)
+#define  SRA                      BIT24
+#define  SRC                      BIT25
+#define  SRD                      BIT26
+
+#define MMCHS_INT_STAT            (MMCHS_BASE + 0x30)
+#define  CC                       BIT0
+#define  BWR                      BIT4
+#define  BRR                      BIT5
+#define  CARD_INS                 BIT6
+#define  ERRI                     BIT15
+
+#define MMCHS_IE                  (MMCHS_BASE + 0x34)
+#define  ALL_EN                   (0xFFFFFFFFUL)
+
+#define MMCHS_ISE                 (MMCHS_BASE + 0x38)
+#define MMCHS_AC12                (MMCHS_BASE + 0x3C)
+#define MMCHS_HC2R                (MMCHS_BASE + 0x3E)
+#define MMCHS_CAPA                (MMCHS_BASE + 0x40)
+#define MMCHS_CUR_CAPA            (MMCHS_BASE + 0x48)
+#define MMCHS_REV                 (MMCHS_BASE + 0xFC)
+
+/*
+ * Command types & Commands
+ */
+#define CMD_R1                    (RSP_TYPE_48BITS | CCCE_ENABLE | CICE_ENABLE)
+#define CMD_R1B                   (RSP_TYPE_48BUSY | CCCE_ENABLE | CICE_ENABLE)
+#define CMD_R2                    (RSP_TYPE_136BITS | CCCE_ENABLE)
+#define CMD_R3                    (RSP_TYPE_48BITS)
+#define CMD_R6                    (RSP_TYPE_48BITS | CCCE_ENABLE | CICE_ENABLE)
+#define CMD_R7                    (RSP_TYPE_48BITS | CCCE_ENABLE | CICE_ENABLE)
+#define CMD_R1_ADTC               (CMD_R1 | DP_ENABLE)
+#define CMD_R1_ADTC_READ          (CMD_R1_ADTC | DDIR_READ)
+#define CMD_R1_ADTC_WRITE         (CMD_R1_ADTC & DDIR_WRITE)
+
+#define CMD0                      (NORMAL_CMD(0))                                     /* Go idle */
+#define CMD1                      (NORMAL_CMD(1) | CMD_R3)                            /* MMC: Send Op Cond */
+#define CMD2                      (NORMAL_CMD(2) | CMD_R2)                            /* Send CID */
+#define CMD3                      (NORMAL_CMD(3) | CMD_R6)                            /* Set Relative Addr */
+#define CMD4                      (NORMAL_CMD(4))                                     /* Set DSR */
+#define CMD5                      (NORMAL_CMD(5) | CMD_R1B)                           /* SDIO: Sleep/Awake */
+#define CMD6                      (NORMAL_CMD(6) | CMD_R1_ADTC_READ)                  /* Switch */
+#define CMD7                      (NORMAL_CMD(7) | CMD_R1B)                           /* Select/Deselect */
+#define CMD8_SD                   (NORMAL_CMD(8) | CMD_R7)                            /* Send If Cond */
+#define  CMD8_SD_ARG              (0x0UL << 12 | BIT8 | 0xCEUL << 0)
+#define CMD8_MMC                  (NORMAL_CMD(8) | CMD_R1_ADTC_READ)                  /* Send Ext Csd */
+#define  CMD8_MMC_ARG             (0)
+#define CMD9                      (NORMAL_CMD(9) | CMD_R2)                            /* Send CSD */
+#define CMD10                     (NORMAL_CMD(10) | CMD_R2)                           /* Send CID */
+#define CMD11                     (NORMAL_CMD(11) | CMD_R1)                           /* Voltage Switch */
+#define CMD12                     (ABORT_CMD(12) | CMD_R1B)                           /* Stop Transmission */
+#define CMD13                     (NORMAL_CMD(13) | CMD_R1)                           /* Send Status */
+#define CMD15                     (NORMAL_CMD(15))                                    /* Go inactive state */
+#define CMD16                     (NORMAL_CMD(16) | CMD_R1)                           /* Set Blocklen */
+#define CMD17                     (NORMAL_CMD(17) | CMD_R1_ADTC_READ)                 /* Read Single Block */
+#define CMD18                     (NORMAL_CMD(18) | CMD_R1_ADTC_READ | MSBS_MULTBLK)  /* Read Multiple Blocks */
+#define CMD19                     (NORMAL_CMD(19) | CMD_R1_ADTC_READ)                 /* SD: Send Tuning Block (64 bytes) */
+#define CMD20                     (NORMAL_CMD(20) | CMD_R1B)                          /* SD: Speed Class Control */
+#define CMD23                     (NORMAL_CMD(23) | CMD_R1)                           /* Set Block Count for CMD18 and CMD25 */
+#define CMD24                     (NORMAL_CMD(24) | CMD_R1_ADTC_WRITE)                /* Write Block */
+#define CMD25                     (NORMAL_CMD(25) | CMD_R1_ADTC_WRITE | MSBS_MULTBLK) /* Write Multiple Blocks */
+#define CMD55                     (NORMAL_CMD(55) | CMD_R1)                           /* App Cmd */
+#define ACMD6                     (NORMAL_CMD(6)  | CMD_R1)                           /* Set Bus Width */
+#define ACMD41                    (NORMAL_CMD(41) | CMD_R3)                           /* Send Op Cond */
+#define ACMD51                    (NORMAL_CMD(51) | CMD_R1_ADTC_READ)                 /* Send SCR */
+#define INVALID_CMD               (0xFFFFFFFFUL)
+
+/* User-friendly command names */
+#define CMD_IO_SEND_OP_COND       CMD5
+#define CMD_SEND_CSD              CMD9 /* CSD: Card-Specific Data */
+#define CMD_STOP_TRANSMISSION     CMD12
+#define CMD_SEND_STATUS           CMD13
+#define CMD_READ_SINGLE_BLOCK     CMD17
+#define CMD_READ_MULTIPLE_BLOCK   CMD18
+#define CMD_SET_BLOCK_COUNT       CMD23
+#define CMD_WRITE_SINGLE_BLOCK    CMD24
+#define CMD_WRITE_MULTIPLE_BLOCK  CMD25
+
+typedef enum _CARD_DETECT_STATE {
+  CardDetectRequired = 0,
+  CardDetectInProgress,
+  CardDetectCompleted
+} CARD_DETECT_STATE;
+
+/**
+ * @brief Checks if card is write-protected
+ *
+ * @param This Pointer to Mmc host protocol instance
+ * @return BOOLEAN
+ * @retval TRUE,  card is write-protected
+ * @retval FALSE, card is not write-protected
+ */
+STATIC
+BOOLEAN
+EFIAPI
+MMCIsReadOnly (
+  IN EFI_MMC_HOST_PROTOCOL  *This
+  );
+
+/**
+ * @brief Adds device path node for Mmc
+ *
+ * @param This Pointer to Mmc host protocol instance
+ * @param DevicePath On input,  points to current device path node.
+ *                   On output, points to next device path node.
+ * @return EFI_STATUS
+ * @retval EFI_SUCCESS New device path node is added
+ * @retval EFI_OUT_OF_RESOURCES Failed to create device path node
+ */
+STATIC
+EFI_STATUS
+EFIAPI
+MMCBuildDevicePath (
+  IN EFI_MMC_HOST_PROTOCOL         *This,
+  IN OUT EFI_DEVICE_PATH_PROTOCOL  **DevicePath
+  );
+
+/**
+ * @brief Send a command
+ *
+ * @param This Pointer to Mmc host protocol instance
+ * @param MmcCmd The command to be sent (MMC_CMDx)
+ * @param Argument Command arguments
+ * @return EFI_STATUS
+ * @retval EFI_SUCCESS Command is sent successfully or ignored
+ * @retval EFI_UNSUPPORTED Command is invalid
+ * @retval EFI_TIMEOUT Timeout occured
+ * @retval EFI_DEVICE_ERROR An error occured while sending the command. Check verbose logs for details.
+ */
+STATIC
+EFI_STATUS
+EFIAPI
+MMCSendCommand (
+  IN EFI_MMC_HOST_PROTOCOL  *This,
+  IN MMC_CMD                MmcCmd,
+  IN UINT32                 Argument
+  );
+
+/**
+ * @brief Notify the Mmc host with current state
+ *
+ * @param This Pointer to Mmc host protocol instance
+ * @param State Only states defined in MMC_STATE (MmcHostProtocol) are accepted
+ * @return EFI_STATUS
+ * @retval EFI_SUCCESS Notification and subsequent operations succeeded
+ * Otherwise, an error value according to which state/operation failed
+ */
+STATIC
+EFI_STATUS
+EFIAPI
+MMCNotifyState (
+  IN EFI_MMC_HOST_PROTOCOL  *This,
+  IN MMC_STATE              State
+  );
+
+/**
+ * @brief Check if a card exists
+ *
+ * @param This Pointer to Mmc host protocol instance
+ * @return BOOLEAN
+ * TRUE Card is detected
+ * FALSE No card present, or failed to detect one
+ */
+STATIC
+BOOLEAN
+EFIAPI
+MMCIsCardPresent (
+  IN EFI_MMC_HOST_PROTOCOL  *This
+  );
+
+/**
+ * @brief Receive a command response
+ *
+ * @param This Pointer to Mmc host protocol instance
+ * @param Type Command type
+ * @param Buffer Buffer to get the response data
+ * @return EFI_STATUS
+ * EFI_SUCCESS Data read successfully
+ */
+STATIC
+EFI_STATUS
+EFIAPI
+MMCReceiveResponse (
+  IN EFI_MMC_HOST_PROTOCOL  *This,
+  IN MMC_RESPONSE_TYPE      Type,
+  OUT UINT32                *Buffer
+  );
+
+/**
+ * @brief Read from card
+ *
+ * @param This Pointer to Mmc host protocol instance
+ * @param Lba Logical block address (not used)
+ * @param Length Length of data to be read
+ * @param Buffer Buffer to get data
+ * @return EFI_STATUS
+ * @retval EFI_SUCCESS Data read successfully
+ * @retval EFI_INVALID_PARAMETER One of the parameters is invalid. Check verbose logs for details.
+ * @retval EFI_TIMEOUT Timeout occured
+ */
+STATIC
+EFI_STATUS
+EFIAPI
+MMCReadBlockData (
+  IN EFI_MMC_HOST_PROTOCOL  *This,
+  IN EFI_LBA                Lba,
+  IN UINTN                  Length,
+  OUT UINT32                *Buffer
+  );
+
+/**
+ * @brief Write to card
+ *
+ * @param This Pointer to Mmc host protocol instance
+ * @param Lba Logical block address (not used)
+ * @param Length Length of data to be written
+ * @param Buffer Buffer that holds data
+ * @return EFI_STATUS
+ * @retval EFI_SUCCESS Data read successfully
+ * @retval EFI_INVALID_PARAMETER One of the parameters is invalid. Check verbose logs for details.
+ * @retval EFI_TIMEOUT Timeout occured
+ */
+STATIC
+EFI_STATUS
+EFIAPI
+MMCWriteBlockData (
+  IN EFI_MMC_HOST_PROTOCOL  *This,
+  IN EFI_LBA                Lba,
+  IN UINTN                  Length,
+  IN UINT32                 *Buffer
+  );
+
+/**
+ * @brief Check if the Mmc Host supports multi-block
+ *
+ * @param This Pointer to Mmc host protocol instance
+ * @return BOOLEAN
+ * TRUE Multi-block is supported
+ */
+STATIC
+BOOLEAN
+EFIAPI
+MMCIsMultiBlock (
+  IN EFI_MMC_HOST_PROTOCOL  *This
+  );
+
+/**
+ * @brief Initialize Mmc Host (driver entry point)
+ *
+ * @param ImageHandle A handle for the image that is initializing this driver
+ * @param SystemTable A pointer to the EFI system table
+ * @return EFI_STATUS
+ * @retval EFI_SUCCESS or same errors as CoreInstallMultipleProtocolInterfaces
+ */
+EFI_STATUS
+MMCInitialize (
+  IN EFI_HANDLE        ImageHandle,
+  IN EFI_SYSTEM_TABLE  *SystemTable
+  );
+
+#endif
diff --git a/Silicon/AMD/Xilinx/CommonPkg/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.inf b/Silicon/AMD/Xilinx/CommonPkg/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.inf
new file mode 100644
index 0000000000..852fbce3a1
--- /dev/null
+++ b/Silicon/AMD/Xilinx/CommonPkg/Drivers/ArasanMmcHostDxe/ArasanMmcHostDxe.inf
@@ -0,0 +1,49 @@
+#/** @file
+#
+#  Copyright (c) 2025, Linaro Ltd. All rights reserved.
+#
+#  SPDX-License-Identifier: BSD-2-Clause-Patent
+#
+#**/
+
+[Defines]
+  INF_VERSION                    = 0x0001001A
+  BASE_NAME                      = ArasanMMCHost
+  FILE_GUID                      = 1448E2EA-337A-48DB-BAD7-0D6A62B6BD38
+  MODULE_TYPE                    = DXE_DRIVER
+  VERSION_STRING                 = 1.0
+  ENTRY_POINT                    = MMCInitialize
+
+[Sources.common]
+  ArasanMmcHostDxe.h
+  ArasanMmcHostDxe.c
+
+[Packages]
+  EmbeddedPkg/EmbeddedPkg.dec
+  MdePkg/MdePkg.dec
+  Silicon/AMD/Xilinx/CommonPkg/CommonPkg.dec
+
+[LibraryClasses]
+  BaseMemoryLib
+  DebugLib
+  DevicePathLib
+  IoLib
+  PcdLib
+  UefiBootServicesTableLib
+  UefiDriverEntryPoint
+
+[Protocols]
+  gEmbeddedMmcHostProtocolGuid  ## PRODUCES
+
+[FixedPcd]
+  gXilinxTokenSpaceGuid.PcdSdhciBase
+  gXilinxTokenSpaceGuid.PcdEnableMmcWPDetection
+  gXilinxTokenSpaceGuid.PcdMmcStallAfterCmdSend
+  gXilinxTokenSpaceGuid.PcdMmcStallAfterResponseReceive
+  gXilinxTokenSpaceGuid.PcdMmcStallAfterDataWrite
+  gXilinxTokenSpaceGuid.PcdMmcStallAfterDataRead
+  gXilinxTokenSpaceGuid.PcdMmcStallAfterRegisterWrite
+  gXilinxTokenSpaceGuid.PcdMmcStallAfterRetry
+
+[Depex]
+  TRUE
